/*******************************************************************
	AviUtl [h vOC

	By NightWork
 *******************************************************************/


#include <stdio.h>
#include <windows.h>
#include <dlgs.h>
#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")
#include "filter.h"

#define _CRT_SECURE_NO_WARNINGS
#define _WINSOCK_DEPRECATED_NO_WARNINGS
#define WIN32_LEAN_AND_MEAN

#define ID_BUTTON_SAVE			40001
#define ID_BUTTON_RELOAD		40002
#define ID_BUTTON_OPEN_AVIUTL_DIR	40003



 /*------------------------------------------------------------------
    global variables
    O[oϐ
  ------------------------------------------------------------------*/
char aviutl_exe_path[FILENAME_MAX];		//AviUtl{̂̃pX
char aviutl_exe_pid[8];				//AviUtlPID
char reload_auf_path[FILENAME_MAX];		//reload.auf̃pX
char reload_auf_dir[FILENAME_MAX];		//reload.auf̃fBNg
char reload_exe_path[FILENAME_MAX];		//reload.exẽpX
char project_path[FILENAME_MAX];		//vWFNgt@CpX

HWND main_window_hwnd;				//CEBhEnh



/*------------------------------------------------------------------
   function prototypes
   ֐vg^Cv
 ------------------------------------------------------------------*/
void	copy_projectfile_path(FILTER* fp, void* editp, unsigned char* path);
int	reboot_aviutl();
int	open_aviutl_dir();



/*------------------------------------------------------------------
   filter infomation
   tB^
 ------------------------------------------------------------------*/
#define	TRACK_N	0
#define CHECK_N 0

FILTER_DLL filter = {
	FILTER_FLAG_ALWAYS_ACTIVE | FILTER_FLAG_INFORMATION | FILTER_FLAG_WINDOW_SIZE | FILTER_FLAG_DISP_FILTER | FILTER_FLAG_MAIN_MESSAGE,
	FILTER_WINDOW_SIZE_CLIENT | 220, FILTER_WINDOW_SIZE_CLIENT | 150,
	"ċN[h",
	TRACK_N,
	NULL,			/* track_name */
	NULL,			/* track_default */
	NULL,NULL,		/* track_s, track_e */
	CHECK_N,
	NULL,			/* check_name */
	NULL,			/* check_default */
	NULL,			/* func_proc */
	func_init,		/* func_init */
	NULL,			/* func_exit */
	NULL,			/* func_update */
	func_WndProc,		/* func_WndProc */
	NULL,NULL,		/* track, check */
	NULL,			/* ex_data_ptr */
	NULL,			/* ex_data_size */
	"20240509 By NightWork",/* information */
	NULL,			/* func_save_start */
	NULL,			/* func_save_end */
	NULL,			/* exfunc */
	NULL,			/* hwnd */
	NULL,			/* dll_hinst */
	NULL,			/* ex_data_def */
	NULL,			/* func_is_saveframe */
	NULL,			/* func_project_load */
	NULL,			/* func_project_save */
	NULL,			/* func_modify_title */
	NULL,			/* dll_path */
	NULL,			/* reserve[2] */
};


/*------------------------------------------------------------------
   export function
   ֐GNX|[g
 ------------------------------------------------------------------*/
FILTER_DLL __declspec(dllexport)* __stdcall GetFilterTable(void)
{
	return &filter;
}


/*------------------------------------------------------------------
   ݒEBhEɃEBhEbZ[WɌĂ΂֐
 ------------------------------------------------------------------*/
BOOL func_WndProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam, void* editp, FILTER* fp)
{
	//Rg[nh
	static HFONT font;			//tHg
	static HWND button_save;		//vWFNg㏑ۑ{^
	static HWND button_reload;		//ċN{^
	static HWND button_open_aviutl_dir;	//Aviutl.exetH_J{^

	SYS_INFO si;		//VXeCtH[V


	//VXeCtH[V擾
	fp->exfunc->get_sys_info(editp, &si);


	//bZ[Weŕ
	switch (message) {

		//CEBhETCYύXEړiNɂj
	case 	WM_FILTER_MAIN_MOVESIZE:

		//EBhEnhۑ
		main_window_hwnd = lparam;

		break;


		//tB^
	case WM_FILTER_INIT:

		//tHgw
		font = CreateFont(12, 0, 0, 0, FW_MEDIUM, FALSE, FALSE, FALSE,
			SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
			PROOF_QUALITY, DEFAULT_PITCH | FF_MODERN, "lr oSVbN");

		//{^zu
		button_save = CreateWindow("BUTTON"
			, "vWFNg̏㏑ۑ"
			, WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON | BS_VCENTER
			, 10, 10
			, 200, 30
			, hwnd
			, (HMENU)ID_BUTTON_SAVE, fp->dll_hinst, NULL);

		button_reload = CreateWindow("BUTTON"
			, "ċN[h"
			, WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON | BS_VCENTER
			, 10, 60
			, 200, 30
			, hwnd
			, (HMENU)ID_BUTTON_RELOAD, fp->dll_hinst, NULL);

		button_open_aviutl_dir = CreateWindow("BUTTON"
			, "Aviutl.exetH_J"
			, WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON | BS_VCENTER
			, 10, 110
			, 200, 30
			, hwnd
			, (HMENU)ID_BUTTON_OPEN_AVIUTL_DIR, fp->dll_hinst, NULL);


		//tHgKp
		SendMessage(button_save, WM_SETFONT, (WPARAM)font, 0);
		SendMessage(button_reload, WM_SETFONT, (WPARAM)font, 0);
		SendMessage(button_open_aviutl_dir, WM_SETFONT, (WPARAM)font, 0);

		break;


		//ڑ
	case WM_COMMAND:
		switch (LOWORD(wparam)) {

			//vWFNg̏㏑ۑ{^ꂽ
		case ID_BUTTON_SAVE:

			//ҏWH
			if (si.flag & SYS_INFO_FLAG_EDIT)
			{
				//vWFNg̏㏑ۑ
				PostMessage(main_window_hwnd, WM_COMMAND, 1024, 0);
			}

			break;

			//[h{^ꂽ
		case ID_BUTTON_RELOAD:

			//ҏWH
			if (si.flag & SYS_INFO_FLAG_EDIT)
			{
				//vWFNgt@C擾
				copy_projectfile_path(fp, editp, project_path); ;
			}
			else {
				sprintf(project_path, "");
			}

			//ċNwp[N
			if (reboot_aviutl())
			{
				//Iv
				Sleep(100);	//ی
				PostMessage(main_window_hwnd, WM_COMMAND, 1002, 0);
			}
			else {
				//s
				MessageBox(main_window_hwnd
					, "ċNɎs܂B"
					, "G["
					, MB_OK);
			}
			break;

			//Aviutl.exetH_J{^ꂽ
		case ID_BUTTON_OPEN_AVIUTL_DIR:

			//Aviutl.exe݂fBNgExplorerŊJ
			if (!open_aviutl_dir())
			{
				//s
				MessageBox(main_window_hwnd
					, "Aviutl.exetH_I[vɎs܂B"
					, "G["
					, MB_OK);
			}
			break;
		}
		break;


		//EBhEj
	case WM_DESTROY:
		break;
	}

	return FALSE;
}


/*-----------------------------------------------------------------
	AviuUtlN
-----------------------------------------------------------------*/
BOOL func_init(FILTER* fp)
{
	//AviUtl.exẽpXPID擾
	GetModuleFileName(NULL, aviutl_exe_path, FILENAME_MAX);
	snprintf(aviutl_exe_pid, 8, "%d", GetCurrentProcessId());

	//reload.auf̃pX擾
	GetModuleFileName(fp->dll_hinst, reload_auf_path, FILENAME_MAX);

	//reload.auf̃fBNg擾
	strcpy(reload_auf_dir, reload_auf_path);
	PathRemoveFileSpec(reload_auf_dir);

	//reload.exẽpX
	snprintf(reload_exe_path, FILENAME_MAX, "%s\\reload.exe", reload_auf_dir);

	return TRUE;
}


/*-----------------------------------------------------------------
	vWFNgt@CpX擾
-----------------------------------------------------------------*/
void  copy_projectfile_path(FILTER* fp, void* editp, unsigned char* path)
{
	SYS_INFO si;

	if (path == NULL) {
		return;
	}

	if (!fp->exfunc->get_sys_info(editp, &si)) {
		path[0] = '\0';
		return;
	}

	strcpy(path, si.project_name);

	return;
}


/*-----------------------------------------------------------------
	ċNwp[ɎsAviUtlPIDApXyсAvWFNgt@CpXԂ񓊂
-----------------------------------------------------------------*/
int reboot_aviutl()
{
	//ϐ
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	char buf[520];		//R}hCobt@
	int ret;		//^[R[h
	ZeroMemory(&si, sizeof(si));


	//R}hC
	snprintf(buf, 520
		, "%s \"%s\" \"%s\" \"%s\""
		, reload_exe_path
		, aviutl_exe_pid
		, aviutl_exe_path
		, project_path);


	//AviUtlċNwp[s
	ret = CreateProcessA(NULL		// s\W[̖
		, buf		// R}hC̕
		, NULL		// ZLeBLqq
		, NULL		// ZLeBLqq
		, FALSE		// nȟpIvV
		, NULL		// 쐬̃tO
		, NULL		// VubN
		, NULL		// JgfBNg̖O
		, &si
		, &pi);

	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);

	return ret;
}


/*-----------------------------------------------------------------
	Aviutl.exetH_J
-----------------------------------------------------------------*/
int open_aviutl_dir()
{
	//ϐ
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	char buf[520];		//R}hCobt@
	int ret;		//^[R[h
	ZeroMemory(&si, sizeof(si));


	//R}hC
	snprintf(buf, 520
		, "explorer.exe /select,%s"
		, aviutl_exe_path);


	//s
	ret = CreateProcessA(NULL		// s\W[̖
		, buf				// R}hC̕
		, NULL				// ZLeBLqq
		, NULL				// ZLeBLqq
		, FALSE				// nȟpIvV
		, NULL				// 쐬̃tO
		, NULL				// VubN
		, NULL				// JgfBNg̖O
		, &si
		, &pi);

	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);

	return ret;
}
